package com.muyu;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.DoubleStream;

/**
 * Demo01
 *
 * @author Yangle
 * Date 2024/5/27 14:06
 */
public class Demo01 {

    public static void main(String[] args) {
        Map<String, Double> hashMap = new HashMap<>(){
            {
                put("node_1", 0.35);
                put("node_2", 0.53);
                put("node_3", 0.17);
                put("node_4", 0.46);
            }
        };

        // 将map转成list
        List<NodeInfo> nodeInfoList = hashMap.entrySet()
                .stream().map(NodeInfo::new)
                .toList();
        System.out.println(nodeInfoList);
      //计算出权重的和
        double sum = nodeInfoList.stream().flatMapToDouble(nodeInfo -> DoubleStream.of(nodeInfo.getWeight()))
                .sum();
        System.out.println(sum);
        BigDecimal spec = new BigDecimal(100).divide(new BigDecimal(sum), 2, BigDecimal.ROUND_HALF_UP);
        System.out.println("spec"+spec);
        java.util.Map<String, Integer> collect = nodeInfoList.stream()
                .collect(Collectors.toMap(NodeInfo::getId,
                        nodeInfo -> spec.multiply(BigDecimal.valueOf(nodeInfo.getWeight())).setScale(0, RoundingMode.DOWN).intValue(),
                        (o1, o2) -> o1));
        System.out.println(collect);
       int  reduce=   collect.values().stream().reduce(0,Integer::sum);
        System.out.println(reduce);
        int free=100-reduce;
         nodeInfoList.stream()
                .sorted(Comparator.comparingInt(o -> o.getWeight().intValue()))
                .limit(free)
                .forEach(nodeInfo ->{
                    collect.put(nodeInfo.getId(),collect.get(nodeInfo.getId())+1);
                        });
        System.out.println(collect);
      String[] nodeArray= new String[100];
      int intArrCursor = -1;
         while (!collect.isEmpty()){
             Iterator<Map.Entry<String, Integer>> specMapIterator = collect.entrySet().iterator();
             while (specMapIterator.hasNext()){
                 Map.Entry<String, Integer> entry = specMapIterator.next();
                 Integer value = entry.getValue();
                 if (value>0){
                     nodeArray[++ intArrCursor]= entry.getKey();
                     entry.setValue(value-1);
                 }
                 if (value ==0){
                     specMapIterator.remove();
                 }
             }
             System.out.println(collect);
             System.out.println("lll"+Arrays.toString(nodeArray));
         }


//        Random random = new Random();
//        //在权重之中进行随机
//        double v = random.nextDouble(sum);
//        for (String ip : hashMap.keySet()) {
//            //权重值
//            Double v1 = hashMap.get(ip);
//            if (v <= v1){
//                System.out.println(ip);
//            }
//            v -=v1;
//        }
    }

}
//class NodeInfo{
//    private String id;
//    private Double weight;
//
//    public NodeInfo (String id,Double weight){
//        this.id = id;
//        this.weight = weight;
//    }
//
//    public NodeInfo(Map.Entry<String, Double> entry) {
//        this.id = entry.getKey();
//        this.weight = entry.getValue() * 100;
//    }
//
//    @Override
//    public String toString() {
//        return "NodeInfo{" +
//                "id='" + id + '\'' +
//                ", weight=" + weight +
//                '}';
//    }
//
//}