package com.muyu;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Map;

/**
 * NodeInfo
 *
 * @author Yangle
 * Date 2024/5/27 21:21
 */
@Data

@NoArgsConstructor
@SuperBuilder
public class NodeInfo {

    private String id;
    private Double weight;

    public NodeInfo (String id,Double weight){
        this.id = id;
        this.weight = weight;
    }

    public NodeInfo(Map.Entry<String, Double> entry) {
        this.id = entry.getKey();
        this.weight = entry.getValue() * 100;
    }

    @Override
    public String toString() {
        return "NodeInfo{" +
                "id='" + id + '\'' +
                ", weight=" + weight +
                '}';
    }
}
