package com.muyu.controller;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.ecs20140526.models.DescribeInstancesResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.tea.TeaModel;
import com.aliyun.teautil.Common;
import com.muyu.ApifoxModel;
import com.muyu.NodeInfo;
import com.muyu.Sample;
import com.muyu.config.RedisConfig;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;


import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.DoubleStream;

/**
 * FluxMqController
 *
 * @author Yangle
 * Date 2024/5/27 17:07
 */
@Log4j2
@RestController
public class FluxMqController {



    @Autowired
    private RestTemplate restTemplate;


    @PostMapping("/getToken")
   public List<String> getToken(@RequestBody ApifoxModel apifoxModel) throws Exception {
        List<String> post = this.post();
        List<String> strings = new ArrayList<>();
        for (String s : post) {
            String s1 = restTemplate.postForObject("http://" + s + ":8080/public/login", apifoxModel, String.class);
            strings.add(s1);
        }
        return strings;
    }
    @Autowired
    private RedisTemplate<String,String> redisTemplate;
    @GetMapping("/select")
    public List<String> getToken(@RequestParam String accessToken) throws Exception {
        List<String> posted = this.post();
        System.out.println(posted);
        List<String> strings = new ArrayList<>();
        for (String s : posted) {
        String s1 = restTemplate.getForObject("http://" + s + ":8080/public/cluster?accesstoken=" + accessToken, String.class);
        System.out.println(s1);
           strings.add(s1);

//           JSONObject.parseObject()
//            JSONObject cpuInfo = jsonObject.getJSONObject("cpuInfo");
//            Double cpu = cpuInfo.getDouble("cpu");
//            hashMap.put(s,cpu);
        }
//        ff();
        return strings;
    }

public static Map<String,Double> hashMap = new HashMap<>();

public static void ff(){
    // 将map转成list
    List<NodeInfo> nodeInfoList = hashMap.entrySet()
            .stream().map(NodeInfo::new)
            .toList();
    System.out.println(nodeInfoList);
    //计算出权重的和
    double sum = nodeInfoList.stream().flatMapToDouble(nodeInfo -> DoubleStream.of(nodeInfo.getWeight()))
            .sum();
    System.out.println(sum);

    BigDecimal spec = new BigDecimal(100).divide(new BigDecimal(sum), 2, BigDecimal.ROUND_HALF_UP);
    System.out.println("spec"+spec);
    java.util.Map<String, Integer> collect = nodeInfoList.stream()
            .collect(Collectors.toMap(NodeInfo::getId,
                    nodeInfo -> spec.multiply(BigDecimal.valueOf(nodeInfo.getWeight())).setScale(0, RoundingMode.DOWN).intValue(),
                    (o1, o2) -> o1));
    System.out.println(collect);
    int  reduce=   collect.values().stream().reduce(0,Integer::sum);
    System.out.println(reduce);
    int free=100-reduce;
    nodeInfoList.stream()
            .sorted(Comparator.comparingInt(o -> o.getWeight().intValue()))
            .limit(free)
            .forEach(nodeInfo ->{
                collect.put(nodeInfo.getId(),collect.get(nodeInfo.getId())+1);
            });
    System.out.println(collect);
    String[] nodeArray= new String[100];
    int intArrCursor = -1;
    while (!collect.isEmpty()){
        Iterator<Map.Entry<String, Integer>> specMapIterator = collect.entrySet().iterator();
        while (specMapIterator.hasNext()){
            Map.Entry<String, Integer> entry = specMapIterator.next();
            Integer value = entry.getValue();
            if (value>0){
                nodeArray[++ intArrCursor]= entry.getKey();
                entry.setValue(value-1);
            }
            if (value ==0){
                specMapIterator.remove();
            }
        }
        System.out.println(collect);
        System.out.println("lll"+Arrays.toString(nodeArray));
    }
}


    public static  final String  postIp = null;


   public static List<String> post() throws Exception {
       List<String> ips=new ArrayList<>();
        com.aliyun.ecs20140526.Client client = Sample.createClient();
       com.aliyun.ecs20140526.models.DescribeInstancesRequest describeInstancesRequest = new com.aliyun.ecs20140526.models.DescribeInstancesRequest()
               .setRegionId("cn-shanghai")
               .setStatus("Running");
       com.aliyun.teautil.models.RuntimeOptions runtime = new com.aliyun.teautil.models.RuntimeOptions();
       try {
           // 复制代码运行请自行打印 API 的返回值
           DescribeInstancesResponse response = client.describeInstancesWithOptions(describeInstancesRequest, runtime);
           String jsonString = Common.toJSONString(TeaModel.buildMap(response));
           System.out.println("hhh" + jsonString);
           JSONObject jsonObject = JSONObject.parseObject(jsonString);
           JSONObject body = jsonObject.getJSONObject("body");
           JSONObject instanceStatuses = body.getJSONObject("Instances");
           JSONArray instanceStatus = instanceStatuses.getJSONArray("Instance");
           for (int i = 0; i < instanceStatus.size(); i++) {
               JSONObject instanceStatus1 = instanceStatus.getJSONObject(i);
               JSONObject publicIpAddress = instanceStatus1.getJSONObject("PublicIpAddress");
               JSONArray ipAddress = publicIpAddress.getJSONArray("IpAddress");
               for (int i1 = 0; i1 < ipAddress.size(); i1++) {
                   ips.add( ipAddress.getString(i1));
               }
           }

       } catch (TeaException error) {
           // 此处仅做打印展示，请谨慎对待异常处理，在工程项目中切勿直接忽略异常。
           // 错误 message
           System.out.println(error.getMessage());
           // 诊断地址
           System.out.println(error.getData().get("Recommend"));
           com.aliyun.teautil.Common.assertAsString(error.message);
       } catch (Exception _error) {
           TeaException error = new TeaException(_error.getMessage(), _error);
           // 此处仅做打印展示，请谨慎对待异常处理，在工程项目中切勿直接忽略异常。
           // 错误 message
           System.out.println(error.getMessage());
           // 诊断地址
           System.out.println(error.getData().get("Recommend"));
           com.aliyun.teautil.Common.assertAsString(error.message);
       }
       return ips;
   }
}

